# Source: physics/p2/PrismaticConstraint.js

    /**
    * @author       Richard Davey <rich@photonstorm.com>
    * @copyright    2014 Photon Storm Ltd.
    * @license      {@link https://github.com/photonstorm/phaser/blob/master/license.txt|MIT License}
    */

    /**
    * Connects two bodies at given offset points, letting them rotate relative to each other around this point.
    *
    * @class Phaser.Physics.P2.PrismaticConstraint
    * @classdesc Physics PrismaticConstraint Constructor
    * @constructor
    * @param {Phaser.Physics.P2} world - A reference to the P2 World.
    * @param {p2.Body} bodyA - First connected body.
    * @param {p2.Body} bodyB - Second connected body.
    * @param {boolean} [lockRotation=true] - If set to false, bodyB will be free to rotate around its anchor point.
    * @param {Array} [anchorA] - Body A's anchor point, defined in its own local frame. The value is an array with 2 elements matching x and y, i.e: [32, 32].
    * @param {Array} [anchorB] - Body A's anchor point, defined in its own local frame. The value is an array with 2 elements matching x and y, i.e: [32, 32].
    * @param {Array} [axis] - An axis, defined in body A frame, that body B's anchor point may slide along. The value is an array with 2 elements matching x and y, i.e: [32, 32].
    * @param {number} [maxForce] - The maximum force that should be applied to constrain the bodies.
    */
    Phaser.Physics.P2.PrismaticConstraint = function (world, bodyA, bodyB, lockRotation, anchorA, anchorB, axis, maxForce) {

        if (typeof lockRotation === 'undefined') { lockRotation = true; }
        if (typeof anchorA === 'undefined') { anchorA = [0, 0]; }
        if (typeof anchorB === 'undefined') { anchorB = [0, 0]; }
        if (typeof axis === 'undefined') { axis = [0, 0]; }
        if (typeof maxForce === 'undefined') { maxForce = Number.MAX_VALUE; }

        /**
        * @property {Phaser.Game} game - Local reference to game.
        */
        this.game = world.game;

        /**
        * @property {Phaser.Physics.P2} world - Local reference to P2 World.
        */
        this.world = world;

        anchorA = [ world.pxmi(anchorA[0]), world.pxmi(anchorA[1]) ];
        anchorB = [ world.pxmi(anchorB[0]), world.pxmi(anchorB[1]) ];

        var options = { localAnchorA: anchorA, localAnchorB: anchorB, localAxisA: axis, maxForce: maxForce, disableRotationalLock: !lockRotation };

        p2.PrismaticConstraint.call(this, bodyA, bodyB, options);

    };

    Phaser.Physics.P2.PrismaticConstraint.prototype = Object.create(p2.PrismaticConstraint.prototype);
    Phaser.Physics.P2.PrismaticConstraint.prototype.constructor = Phaser.Physics.P2.PrismaticConstraint;